window.gSTB = {};

//console.log('Platform: ' + window.navigator.platform);
//console.log('Vendor: ' + window.navigator.vendor);

try {
    Object.defineProperty(
        navigator,
        "vendor",
        {
            get: function () {
                return "Infomir";
            },
            set: function (a) {
            }
        });
}
catch(e) {}

function retraceError(e, value, args)
{
    try{
        var toType = function(obj) {
            try{
                return ({}).toString.call(obj).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
            }
            catch (e)
            {
                console.error(e);
                return '';
            }

        };

        args = args || [];

        var argList = [];
        for(var index = 0; index < args.length; index++)
        {
            var arg = args[index];
            argList[index] = (typeof arg) + ":" + arg;
        }

        var errorData = [];
        errorData.push("");
        errorData.push("Message: " + e.message);
        //errorData.push("Name: " + id);
        errorData.push("Type of result: " + toType(value));
        //try{
        //    errorData.push("Method definition: " + window[objName][id]);
        //}
        //catch(e){}

        errorData.push("Arguments: [" + argList.join(', ') + ']');
        errorData.push("Error name: " + e.name);
        errorData.push("Error code: " + e.number);
        errorData.push("");
        errorData.push("backtrace: \n" + e.stack);

        console.error(errorData.join('\n'));
    }
    catch(e)
    {
        console.error(e);
    }
    return false;
}

window['retraceError'] = retraceError;
window.retraceError = retraceError;

(function(temp_object, functions) {
    if(typeof window.parent == 'undefined')
    window.parent = {
        gSTB: gSTB
    };

    if(typeof stb === 'undefined' || typeof stb != 'object')
    {
        window.stb = gSTB;
    }

    var tmpObject = {};

    functions.map(function(id)
    {
        var asJSON = /^JSON_.*$/.test(id);
        var methodId = asJSON ? id.replace(/^JSON_(.*?)$/, '$1') : id;
        /**
         * @var {string} id
         */
        tmpObject[methodId] = function()
        {
            var args = Array.prototype.slice.call(arguments);
            //console.log('Calling ' + id + "(" + args.join(",") + "), len:" + args.length  );
            for(var index = 0; index < args.length; index++) {
                if(typeof args[index] === 'undefined')
                    args[index] = null;

                if(typeof args[index] === 'object') {
                    var json = JSON.stringify(args[index]);
                    console.log('Argument for method ' + methodId + ' was converted to JSON: ' + json);
                    args[index] = json;
                }
            }

            try {
                var value = temp_object[id].apply(temp_object, args);
                // In Android 3 Java type "String" converts into "object" so Monkey Patching in Stalker portal doesn't work.
                // [bugfix]
                if(typeof value === "object")
                    value = '' + value;

                //console.log("returns: " + value);
                return asJSON ? JSON.parse(value) : value;
            } catch(e) {
                retraceError(e, args);
                throw e;
            }
        }
    });

    if(window['Proxy']) {
        var setProxy = function(obj) {
            'use strict';
            return new Proxy(obj, {
                get: function(target, name) {
                    if(typeof target[name] === 'undefined') {
                        if(name.length > 0 && name[0] == name[0].toUpperCase()) {
                            console.warn('PROXY: Value not found: ' + name);
                        }
                    }
                    return target[name];
                },
                set: function(target, name, value) {
                    //console.log('PROXY: set ' + name + ' -> ' + value);
                    target[name] = value;
                    return true;
                }
            });
        };

        tmpObject.IsEmulator = false;
        window.stb = setProxy(tmpObject);
        window.gSTB = setProxy(tmpObject);
    } else {
        window.stb = tmpObject;
        window.gSTB = tmpObject;
    }
})(window["$object$"], $functions$);

top.getAppManager = function()
{
    return {
        getCurrentApp: function()
        {
            return '';
        },
        getRealCurrentApp: function()
        {
            return '';
        }
    };
};

(function() {
    window.$$locStorage = function() {

    };

    window.$$locStorage.prototype = window.localStorage;
})();

/**
 * Android 4.4 only!
 */
if(typeof cookieManager !== 'undefined') {
    (function() {
        Object.defineProperty(this.document, 'cookie', {
            get: function() {
                console.log('Get cookie');
                var res = cookieManager.getCookie(document.location.href);
                console.log(' --> ' + res);
                return res;
            },
            set: function(value) {
                console.log('Set cookie: ' + JSON.stringify(document.location.href) + " -> " +  value);
                cookieManager.setCookie(document.location.href, value);
            },
            enumerable : true,
            //writable: true,
            configurable: true
        });
    })(document.cookie);
}

